with (import <nixpkgs> {});

let
  hp = haskellPackages.extend (self: super: {
    buuka = haskellPackages.callPackage ./. {};
  });
  easy-hls-src = fetchFromGitHub {
    owner = "ssbothwell";
    repo = "easy-hls-nix";
    inherit (builtins.fromJSON (builtins.readFile ./easy-hls-nix.json)) rev sha256;
  };
  easy-hls = callPackage easy-hls-src { ghcVersions = [ hp.ghc.version ]; };

in

hp.shellFor {
  packages = h: [h.buuka];
  buildInputs = [
    hlint
    ghcid
    stylish-haskell
    cabal2nix
    cabal-install
    easy-hls
  ];
}
